
% Observer stimation of descritor system. THis example is based on
%IEEE  TRANSACTIONS  ON AUMMATIC  CONTROL, VOL.  40, NO.  7. JULY  I995 
%Design of  Observers for Descriptor Systems 
%M.  Darouach  and  M.  Boutayeb 
%clear;

clc;
clear();
close();
disp('Descriptor system')
%% definigng the descriptor system
E=[1 0 0 0 ; 0 1 0 0; 0 0 0 0; 0 0 0 0]
A=[0 0 1 0 ; 1 0 0 0; -1 0 0 1; 0 1 1 1]
B=[0 0 0 -1]'
C=[0 1 0 0; 1 0 1 0]
%check observability
disp('observability')

pause
 [nC,Co_mat,nR,Ro_mat,nI,Io_mat]=dobsv(E,A,C)

 % if the system is observable then compute the restricted system equivalence systems by QR descomposition

disp('if the system is observable then compute the restricted system equivalence systems by QR descomposition')
pause
[Ee, Ae, Ae1, Be, Be1, Ce]=qrrse(E,A,B,C)
 
% compute the gains of the observer 
disp('Poles of the observer')
poles=[-4,-3,-2,-1];
disp('Building an structure with the matrices of the descriptor system')
pause
dsys=dsystem(E,A,B,C)
disp('computing the gains of the observer')
pause

[N,K,L1,L2,G,test]=darobsv95(dsys,poles)
disp('a, b, c and d coeffients of Daoruach observer')
[a,b,c,d,rcon]=abcdcoeff(E,A,B,C)
disp('Simulation of the system and the observer')
Te=0.1;
x1(1)=0; x2(1)=0;x3(1)=0; x4(1)=0;
% set of intial conditions
    xx(:,1)=[x1(1) x2(1) x3(1) x4(1)]';
    y(:,1)=C*xx;
% initial conditions for the observer

z=[0 0 0 0]';
xe=[ 1 5 3 0]';% intial stimated states
ye(:,1)=C*xe; % compute the initial output
t(1)=0;% initial time
u(1)=0;

for k=1:50/Te
     % Time counter
    t(k+1)=t(k)+Te;
    % input
    if t(k)<7 
        u(k+1)=sin(t(k));
    else
        u(k+1)=5;
    end
    if t(k)>20 & t(k)<30 
        fa=1;
    else
        fa=0;
    end
    %    % the differentials equations can be solved by runge-kuta of four order
    x1=x1+Te*(x3);
    x2=x2+Te*(x1);
    x4=x1;
    x3=-x2-x4+u(k);
    xx(:,k+1)=[x1 x2 x3 x4]';
    y(:,k+1)=C*xx(:,k+1)+[1 ;0]*fa;
     % Observer
  
     z(:,k+1)=z(:,k)+Te*(N*z(:,k)+L1*[-Be1*u(k);C*xx(:,k)]+L2*[-Be1*u(k);C*xx(:,k)]+G*u(k));
     xe(:,k+1)=z(:,k+1)+b*[-Be1*u(k);C*xx(:,k+1)]+K*d*[-Be1*u(k);C*xx(:,k+1)];
     ye(:,k+1)=C*xe(:,k+1);
end

disp('ploting responses')
pause
figure(1);cla();
subplot(211);
plot(t,xx,t,xe)
subplot(212);
plot(t,u);
figure(2);
cla();
plot(t,y',t,ye')
