% Reduced-Order  Observer Design for Descriptor Systems  with  Unknown  Inputs 
% M.  Darouach,  M. Zasadzinski,  and  M.  Hayar , 1996
clc;
clear;
%
disp('Descriptor System matrices')
pause

E=[1 0 0 0 ; 0 1 0 0; 0 0 1 0; 0 0 0 0]
A=[-1 1 0 0 ; -1 0 0 1; 0 -1 -1 0; 0 0 0 1]
B=[1 0 0 1; 0 1 0 0]'
C=[1 0 0 0; 0 0 1 1]

F=[-1 0 0 0]'
G=[0 0]'
%%
disp('Computing the gains of the observer')
pause
dsys=dsystem(E,A,B,C,F,G);
[Pi, L1, L2, H, M, N,C11,C12]=darobsv96(dsys)


%%
disp('Inputs')
pause
Te=0.1;
x1(1)=0; x2(1)=0;x3(1)=0; x4(1)=0;
z1(1)=0; z2(1)=0;z3(1)=0; z4(1)=0;
x1e(1)=0; x2e(1)=0;x3e(1)=0; x4e(1)=0;
t(1)=0;
u1=5;
u2=3;
U=[u1;u2]
%w1=1;
w2=0;
%w=[1;0;0];
%w1=1;
%w2=[0;0];

%W=V*w;
disp('Initial conditions')
pause
% initialas conditions
xx(:,1)=zeros(4,1)
xe(:,1)=[2 3 1 2]'
y(:,1)=C*xx
ye(:,1)=C*xe
z(1)=0


disp('Simulation  of the observer and the system')
disp('Considering an unknown iput in 10<t<20')
for k=1:50/Te
    
    if t(k)>10 & t(k)<20 
    w1=2;
    w2=0;
else
    w1=0;
    w2=0;
    end
    % System
    t(k+1)=t(k)+Te;
    x13=xx(1:3,k)+Te*(A(1:3,:)*xx(:,k)+B(1:3,:)*U+F(1:3,:)*w1);
    
    x4=(A(4,1:3)*xx(1:3,k)+B(4,:)*U+F(4,:)*w1)/A(4,4);
    
    xx(:,k+1)=[x13 ;x4];
     % Observer
      if rank(C11)==0
          y1=w1;
      else
     y1=C11+w1;
      end
     y2=C12*xx(:,k);

     z(k+1)=z(k)+Te*(Pi*z(k)+L1*y1+L2*y2+H*U);
     xe(:,k+1)=M*z(k)+N*y2;
     ye(:,k+1)=C*xe(:,k);
end


disp('PLOTS')
pause

figure(1);cla();
plot(t,xx,t,xe)
figure(2);
cla();
subplot(211)
plot(t,ye(1,:)')
subplot(212)
plot(t,ye(2,:)')
%plot(t,xe)
