% Reduced-Order  Observer Design for Descriptor Systems  with  Unknown  Inputs 
% M.  Darouach,  M. Zasadzinski,  and  M.  Hayar , 1996
%% Feedback control admissibility as in Xu, page 75 Theorem 3
clc;
clear;
%
% disp('Descriptor System matrices')
% pause

E=[1 0 0 0 ; 0 1 0 0; 0 0 1 0; 0 0 0 0]
A=[-1 1 0 0 ; -1 0 0 1; 0 -1 -1 0; 0 0 0 1]
B=[0 0 0 1; 0 1 0 0]'
C=[1 0 0 0; 0 0 1 1]

Bd=[-1 0 0 0]'
D=[1 0; 0 1]'
 S=[0 0 0 1]'
[K,lamda,g]=dfeedback_control(E,A,B,Bd,C,D,S,1);
%%

Te=0.01;
x1(1)=0; x2(1)=0;x3(1)=0; x4(1)=0;
z1(1)=0; z2(1)=0;z3(1)=0; z4(1)=0;
x1e(1)=0; x2e(1)=0;x3e(1)=0; x4e(1)=0;
t(1)=0;
u1=4;
u2=3;
U=[u1;u2];
%w1=1;
w2=0;

% initialas conditions
xx(:,1)=[0.2 3 0.1 0];
xe(:,1)=[2 3 1 2]';
y(:,1)=C*xx;
ye(:,1)=C*xe;
xxc(:,1)=zeros(4,1);
yc(:,1)=C*xxc; 
z(1)=0;


% disp('Simulation  of the observer and the system')
% disp('Considering an unknown iput in 10<t<20')
for k=1:50/Te
    
    if t(k)>10 & t(k)<20 
    w1=0.02*rand(1);
    w2=0;
else
    w1=0;
    w2=0;
    end
    % System
%     U=[sin(t(k));2];
    t(k+1)=t(k)+Te;
    x13=xx(1:3,k)+Te*(A(1:3,:)*xx(:,k)+B(1:3,:)*U+Bd(1:3,:)*w1);
    x4=(A(4,1:3)*xx(1:3,k)+B(4,:)*U+Bd(4,:)*w1)/-A(4,4);
    xx(:,k+1)=[x13 ;x4];
    y(:,k+1)=C*xx(:,k+1);
    
    %%COntrolled
      Uc=K*xxc(:,k);

 xxc(1:3,k+1)=xxc(1:3,k)+Te*(A(1:3,:)*xxc(:,k)+B(1:3,:)*Uc+Bd(1:3,:)*w1); 
 xxc(4,k+1)=-B(4,:)*Uc-Bd(4,:)*w1;

    yc(:,k+1)=C*xxc(:,k+1);
  
end

% 
% disp('PLOTS')
% pause

figure(1);cla();
plot(t,xxc)
legend('Stabilized systems')
figure(2);
cla();
% subplot(211)
plot(t,y,t,yc)
legend('y_1', 'y_2', 'y_1 estable','Y_2 estable')

