% Reduced-Order  Observer Design for Descriptor Systems  with  Unknown  Inputs 
% M.  Darouach,  M. Zasadzinski,  and  M.  Hayar , 1996
%Tracking example by considering and integrator compesator 
%% Feedback control admissibility as in Xu, page 75 Theorem 3
clc;
clear;
%
% disp('Descriptor System matrices')
% pause

E=[1 0 0 0 ; 0 1 0 0; 0 0 1 0; 0 0 0 0];
A=[-1 1 0 0 ; -1 0 0 1; 0 -1 -1 0; 0 0 0 1];
B=[0 0 0 1; 0 1 0 0]';
C=[1 0 0 0; 0 0 1 1];

Bd=[-1 0 0 0]';
D=[1 0; 0 1]';
 S=[0 0 0 1]';
%%Augmented system
Ea=[E zeros(4,2); zeros(2,4) eye(2,2)];
Aa=[A zeros(4,2); -C zeros(2,2)];
Ba=[B; zeros(2,2)];
Br=[zeros(4,2); eye(2,2)];
Ca=[C zeros(2,2)];
S=[0 0 0 1 0 0]';
[K,lamda]=admissibility_control(Ea,Aa,Ba,S,3)
K1=K(:,1:4);
K2=K(:,5:6);

%%
h=size(A,3);
n=size(A,1);
m=size(B,2);
B3=D;
H=C;

Te=0.01;
x1(1)=0; x2(1)=0;x3(1)=0; x4(1)=0;
z1(1)=0; z2(1)=0;z3(1)=0; z4(1)=0;
x1e(1)=0; x2e(1)=0;x3e(1)=0; x4e(1)=0;
t(1)=0;
u1=4;
u2=3;
U=[u1;u2];
%w1=1;
w2=0;

% initialas conditions
xx(:,1)=[0.2 3 0.1 0];
xa=[0;0]
xe(:,1)=[2 3 1 2]';
z=xx;

y(:,1)=C*xx;
ye(:,1)=C*xe;
xxc(:,1)=zeros(4,1);
yc(:,1)=C*xxc; 
z(1)=0;


% disp('Simulation  of the observer and the system')
% disp('Considering an unknown iput in 10<t<20')
for k=1:70/Te
    
    if t(k)>10 & t(k)<20 
    w1=0.02*rand(1);
    w2=0;
else
    w1=0;
    w2=0;
    end
    % System
%     U=[sin(t(k));2];
    t(k+1)=t(k)+Te;
    r(:,k+1)=[-2;5];
%    Ua=-K*xa(:,k);
if t(k)<=20
       r(:,k+1)=[1;-3];
elseif t(k)>20 & t(k)<50
      r(:,k+1)=[-2;1];
else
         r(:,k+1)=[2;-5];
end
   
%%PI controller r=reference
   xa(:,k+1)=xa(:,k)+Te*(r(:,k+1)-y(:,k));
   U1=K2*xa(:,k+1);
   
    U=U1+K1*xx(:,k);
    %%%controlled system
    x13=xx(1:3,k)+Te*(A(1:3,:)*xx(:,k)+B(1:3,:)*U+Bd(1:3,:)*w1);
    x4=(A(4,1:3)*xx(1:3,k)+B(4,:)*U+Bd(4,:)*w1)/-A(4,4);
    xx(:,k+1)=[x13 ;x4];
    y(:,k+1)=C*xx(:,k+1);
      
end



figure(2);
cla();
subplot(211)
plot(t,r(1,:),t,y(1,:))
legend('Ref 1',  'Output 1')
subplot(212)
plot(t,r(2,:),t,y(2,:))
legend( 'Ref2',  'Output 2')
% legend('Uncontrolled1','Uncontrolled2','Controlled1','Controlled2')
% subplot(212)
% plot(t,ye(2,:)')
% %plot(t,xe)
