
clear all;
clc;
  theta1=[-0.05 0.05]; %[ ]
  theta2=[-0.1 0.1 ];
  
  % genering a matrix with the two parameter varying
  n=0;
  for k=1:2
      for j=1:2
          n=n+1;
          theta(n,:)=[theta1(k) theta2(j) ];
      end
  end
  
  % descriptor system, constant matrices
  E=[1 0 0 0; 0 1 0 0; 0 0 0 0; 0 0 0 0];
  
%   C=[1 0 0 0; 0 1 0 1];;
C=[1 0 1 0; 0 1 0 1; 1 0 0 0]  
  
  % Building the parameter varying matrices
  for j=1:4
      
  A(:,:,j)=[0 1 0 0; -1  theta(j,1) 0 0; 0 -1 -1+theta(j,1) 0; 0 0 0 -1+theta(j,2)];
      
  B(:,:,j)=[1+theta(j,1) 1;1 theta(j,2); 0 0 ;0.5-theta(j,2) 0];
      
  R(:,:,j)=[1 theta(j,2) 0 0]';
  end
  %% descriptor system
   
  alpha=3;

  % computing the gains of the bank of observer
 [Co]=BCmatricesGOs(C,'s')
  dsys=dsystem(E,A,B,Co(:,:,1),R)
  [N,G1,L,H2,B1]=lpvpuiobsv(dsys,alpha,'sedumi')
%%Observer 2
  dsys=dsystem(E,A,B,Co(:,:,2),R)
  [N2,G12,L2,H22,B12]=lpvpuiobsv(dsys,alpha)
%%Observer 3
    dsys=dsystem(E,A,B,Co(:,:,3),R)
  [N3,G13,L3,H23,B13]=lpvpuiobsv(dsys,alpha)

  
%   Model simulation

%% initial conditions oberver
xx=zeros(4,1);
z=[0 0 0.2 0]';
z2=[0 0 0 0]';
z3=[0.1 0 0 0]';
xe=[5 3 4 1]';
y(:,1)=C*xx(:,1); 
ye=Co(:,:,1)*xe(:,1); 
ye2=Co(:,:,2)*xe(:,1); 
ye3=Co(:,:,3)*xe(:,1); 
t(1)=0;

%inputs
u1=5; u2=7; d=0;
U=[u1;u2];
load Thetas; %% vector of measured parameters
Theta1=Thetas(:,1); %% these were invented for simulation purpouses
Theta2=Thetas(:,2);

Te=0.01
for k=1:50/Te
        %% unknown Input in t=5
%     if t(k)>5 & t(k)>10
%         d(k+1)=6; %% unknown input
%     else
%         d(k+1)=0;
%     end
d(k+1)=0;rand(1);    %% Disturbance

   %%Faults
   f1=0;f2=0; f3=0;
   if t(k)>=10 && t(k)<=15
       f1=5;%0.22;%//wgn(1,1,0.1);
   end
      if t(k)>=20 && t(k)<=30
       f2=2*square(100*t(k));;%rand(1)/50;%wgn(1,1,0);
%        if f2==-0.2;
%            f2=0;
%        end
     
   end
   
      if t(k)>=35&& t(k)<=45
       f3=-2*sin(10*t(k));;%rand(1)/50;%wgn(1,1,0);
      end
      
   f(:,k+1)=[f1;f2;0];
    %% System
    
    
    t(k+1)=t(k)+Te;
    %%Gains scheduling functions
    Theta1(k+1)= 0.002*t(k)-0.05;%square(0.1*t(k));
    Theta2(k+1)=0.1*sin(t(k));
    mu1=((Theta1(k)+0.05)*(Theta2(k)+0.1))/0.02;
    mu2=((Theta1(k)+0.05)*(0.1-Theta2(k)))/0.02;
    mu3=((0.05-Theta1(k))*(Theta2(k)+0.1))/0.02;
    mu4=((0.05-Theta1(k))*(0.1-Theta2(k)))/0.02;
        rho=[mu1 mu2 mu3 mu4];
    rhos(k+1,:)=[mu1 mu2 mu3 mu4  mu1+mu2+mu3+mu4];
   


Aa=rho(1)*A(:,:,1)+rho(2)*A(:,:,2)+rho(3)*A(:,:,3)+rho(4)*A(:,:,4);
Ba=rho(1)*B(:,:,1)+rho(2)*B(:,:,2)+rho(3)*B(:,:,3)+rho(4)*B(:,:,4);
 Bda=rho(1)*R(:,:,1)+rho(2)*R(:,:,2)+rho(3)*R(:,:,3)+rho(4)*R(:,:,4);


xx(1:2,k+1)=xx(1:2,k)+Te*(Aa(1:2,:)*xx(:,k)+Ba(1:2,:)*U+Bda(1:2,:)*d(k));
xx(3:4,k+1)=inv(Aa(3:4,3:4))*(-Ba(3:4,:)*U-Aa(3:4,1:2)*xx(1:2,k+1));
y(:,k+1)=C*xx(:,k+1)+eye(3,3)*f(:,k+1);
%      y(:,k+1)=C*xx(:,k+1); 
    %%% R.S.E Model
    
    
    %%Observer Design
    %%%%%%Observer1 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    U=[u1 u2]';
    
    Ni=rho(1)*N(:,:,1)+rho(2)*N(:,:,2)+rho(3)*N(:,:,3)+rho(4)*N(:,:,4);
    Gi=rho(1)*G1(:,:,1)+rho(2)*G1(:,:,2)+rho(3)*G1(:,:,3)+rho(4)*G1(:,:,4);
    Li=rho(1)*L(:,:,1)+rho(2)*L(:,:,2)+rho(3)*L(:,:,3)+rho(4)*L(:,:,4);
    H2i=rho(1)*H2(:,:,1)+rho(2)*H2(:,:,2)+rho(3)*H2(:,:,3)+rho(4)*H2(:,:,4);
    B1i=rho(1)*B1(:,:,1)+rho(2)*B1(:,:,2)+rho(3)*B1(:,:,3)+rho(4)*B1(:,:,4);

    ya=[y(2,k+1);y(3,k+1)];
 z(:,k+1)=z(:,k)+Te*(Ni*z(:,k)+Gi*U+Li*[-B1i*U ; ya]);
xe(:,k+1)=z(:,k+1)+H2i*[-B1i*U ; ya];
    
   ye(:,k+1)=Co(:,:,1)*xe(:,k+1);
    r(:,k+1)= norm(ya-ye(:,k+1));
  %%%%%%Observer2 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    Ni2=rho(1)*N2(:,:,1)+rho(2)*N2(:,:,2)+rho(3)*N2(:,:,3)+rho(4)*N2(:,:,4);
    Gi2=rho(1)*G12(:,:,1)+rho(2)*G12(:,:,2)+rho(3)*G12(:,:,3)+rho(4)*G12(:,:,4);
    Li2=rho(1)*L2(:,:,1)+rho(2)*L2(:,:,2)+rho(3)*L2(:,:,3)+rho(4)*L2(:,:,4);
    H2i2=rho(1)*H22(:,:,1)+rho(2)*H22(:,:,2)+rho(3)*H22(:,:,3)+rho(4)*H22(:,:,4);
    B1i2=rho(1)*B12(:,:,1)+rho(2)*B12(:,:,2)+rho(3)*B12(:,:,3)+rho(4)*B12(:,:,4);

    ya=[y(1,k+1);y(3,k+1)];
 z2(:,k+1)=z2(:,k)+Te*(Ni2*z2(:,k)+Gi2*U+Li2*[-B1i2*U ; ya]);
xe2(:,k+1)=z2(:,k+1)+H2i2*[-B1i2*U ; ya];
    
   ye2(:,k+1)=Co(:,:,2)*xe2(:,k+1);
    r2(:,k+1)= norm(ya-ye2(:,k+1));
  
  
    %%%%%%Observer3 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 Ni3=rho(1)*N3(:,:,1)+rho(2)*N3(:,:,2)+rho(3)*N3(:,:,3)+rho(4)*N3(:,:,4);
    Gi3=rho(1)*G13(:,:,1)+rho(2)*G13(:,:,2)+rho(3)*G13(:,:,3)+rho(4)*G13(:,:,4);
    Li3=rho(1)*L3(:,:,1)+rho(2)*L3(:,:,2)+rho(3)*L3(:,:,3)+rho(4)*L3(:,:,4);
    H2i3=rho(1)*H23(:,:,1)+rho(2)*H23(:,:,2)+rho(3)*H23(:,:,3)+rho(4)*H23(:,:,4);
    B1i3=rho(1)*B13(:,:,1)+rho(2)*B13(:,:,2)+rho(3)*B13(:,:,3)+rho(4)*B13(:,:,4);

    ya=[y(1,k+1);y(2,k+1)];
 z3(:,k+1)=z3(:,k)+Te*(Ni3*z3(:,k)+Gi3*U+Li3*[-B1i3*U ; ya]);
xe3(:,k+1)=z3(:,k+1)+H2i3*[-B1i3*U ; ya];
    
   ye3(:,k+1)=Co(:,:,3)*xe3(:,k+1);
    r3(:,k+1)= norm(ya-ye3(:,k+1));
        
end

figure(1); 
subplot(231); plot(t,y(2,:),t,ye(1,:)), legend('x_1 Real', 'Estimated')
xlabel('Time'), ylabel('Amplitude'); title('Observer 1')
subplot(234); plot(t,y(3,:),t,ye(2,:)), legend('x_2 Real', 'Estimated')
xlabel('Time'), ylabel('Amplitude')
subplot(232); plot(t,y(1,:),t,ye2(1,:)), legend('x_1 Real', 'Estimated')
xlabel('Time'), ylabel('Amplitude')
subplot(235); plot(t,y(3,:),t,ye2(2,:)), legend('x_2 Real', 'Estimated')
xlabel('Time'), ylabel('Amplitude'); title('Observer 3')
subplot(233); plot(t,y(1,:),t,ye3(1,:)), legend('x_1 Real', 'Estimated')
xlabel('Time'), ylabel('Amplitude'); title('Observer 3')
subplot(236); plot(t,y(2,:),t,ye3(2,:)), legend('x_2 Real', 'Estimated')
xlabel('Time'), ylabel('Amplitude')


figure(5); cla();
subplot(411),plot(t,r), legend('res1')
title('Residuals: Observer 1'),grid
xlabel('Time'), ylabel('Amplitude')
subplot(412),plot(t,r2), legend('res2'),grid
xlabel('Time'), ylabel('Amplitude'), title('Residuals: Observer 2')
subplot(413),plot(t,r3), legend('res3'),grid
xlabel('Time'), ylabel('Amplitude'); title('Residuals: Observer 3')
subplot(414),plot(t,f), legend('f_1','f_2','f_3')
xlabel('Time'), ylabel('Amplitude')
