function [K,lamda]=admissibility_control(E,A,B,S,flag)
% [K]=admissibility_control(E,A,B,S)
% Verify admissiblity for  feedback control
% u=Kx, then  the close loop system is 
% Edotx=(A+BK)x
% S=is any matrix such that E*S=0
% K=Feedback gain
% lamda= eigenvalues of (E, A+BK)

n=size(A,1);
m=size(B,2);
% p=size(C,1);
if flag==1
P=sdpvar(n,n);
Y=sdpvar(m,n,'full');
Q=sdpvar(1,n,'full');

alpha=3;
Con=[ (P*E'+S*Q)'*A'+Y'*B'+A*(P*E'+S*Q)+B*Y+2*alpha*P<=0,  P>=0];
op=sdpsettings('verbose',0,'solver','sedumi');
solvesdp(Con,-trace(P),op)

P=double(P);
Y=double(Y);
Q=double(Q);
%  K=Y/((P*E'+S*Q))
K=Y/((P*E'+S*Q))
lamda=deig(A+B*K,E);
% [Ccon, Rcon, Icon]=dcontr (E,A+B*K,B)

elseif flag==2
    
cvx_begin sdp
% cvx_precision default
    cvx_solver sedumi
% variable g
    variable P(n,n) symmetric
    variable Y(m,n)
    variable Q(1,n)
    minimize(-trace(P))
    alpha=2;
    P >= 0
     (P*E'+S*Q)'*A'+Y'*B'+A*(P*E'+S*Q)+B*Y+2*alpha*P <= 0
%  (P*E'+S*Q)'*A'+Y'*B'+A*(P*E'+S*Q)+B*Y+2*alpha*P <= 0
cvx_end

K=Y/(P*E'+S*Q)
lamda=deig(A+B*K,E)

else
   
setlmis([]);
% create a blank LTI framework
P=lmivar(1,[n 1]); % declare X as a 3 × 3 symmetrical matrix    
Y=lmivar(2,[m n]); % declare Y as a n x n     
Q=lmivar(2,[1 n]); % declare    
lmiterm([1 1 1 P],A,E','s') % A*P*E' + *
lmiterm([1 1 1 Q],A*S,1,'s') % A*S*Q+*
lmiterm([1 1 1 Y],B,1,'s') % B*Y+*
% lmiterm([1 1 1 P],2*5,1,'s') % B*Y+*
lmiterm([-2 1 1 P],1,1,'s') % P>0
% lmiterm([-3 1 1 Q],1,1) % P>0
Con=getlmis;
% c = mat2dec(Con,eye(3),eye(3),eye(1,n));
% options = [1e5,0,0,0,0];
% [copt,b] = mincx(Con,c,options);
[tmin b]=feasp(Con);
% [tmin b]=mincx(Con,-trac);
P=dec2mat(Con,b,P);
Y=dec2mat(Con,b,Y);
Q=dec2mat(Con,b,Q);
K=Y/((P*E'+S*Q));
lamda=deig(A+B*K,E);

end
