function [K,lamda]=dadmissibility_LPV(E,A,B,S,flag)
% [K]=admissibility_control(E,A,B,S)
% Verify admissiblity for  feedback control
% u=Kx, then  the close loop system is 
% Edotx=(A+BK)x
% S=is any matrix such that E*S=0
% K=Feedback gain
% lamda= eigenvalues of (E, A+BK)

n=size(A,1);
m=size(B,2);
% p=size(C,1);
h=size(A,3);
if flag==1
P=sdpvar(n,n);
Y=sdpvar(m,n,h,'full');
Q=sdpvar(1,n,'full');

Con=[P>=0];
for j=1:h
alpha=3;
Con=[Con, (P*E'+S*Q)'*A(:,:,j)'+Y(:,:,j)'*B'+A(:,:,j)*(P*E'+S*Q)+B*Y(:,:,j)+2*alpha*P<=0];
end
op=sdpsettings('verbose',0,'solver','sedumi');
solvesdp(Con,[],op)

P=double(P)
Y=double(Y)
Q=double(Q)
%  K=Y/((P*E'+S*Q))
for j=1:h
K(:,:,j)=Y(:,:,j)/((P*E'+S*Q));
lamda=deig(A(:,:,j)+B*K(:,:,j),E);
end
% [Ccon, Rcon, Icon]=dcontr (E,A+B*K,B)

elseif flag==2
    
cvx_begin sdp
% cvx_precision default
    cvx_solver sedumi
% variable g
    variable P(n,n) symmetric
    variable Y(m,n,h)
    variable Q(1,n)
%     minimize(-trace(P))
    alpha=2;
    P >= 0
    for j=1:h
     (P*E'+S*Q)'*A(:,:,j)'+Y(:,:,j)'*B'+A(:,:,j)*(P*E'+S*Q)+B*Y(:,:,j)+2*alpha*P <= 0
    end
cvx_end
for j=1:3
K(:,:,j)=Y(:,:,j)/(P*E'+S*Q);
lamda(j)=deig(A(:,:,j)+B*K(:,:,j),E);
end
else
   
setlmis([]);
% create a blank LTI framework
P=lmivar(1,[n 1]); % declare X as a 3 × 3 symmetrical matrix    
Y=lmivar(2,[m n ]); % declare Y as a n x n     
Y2=lmivar(2,[m n ]); % declare Y as a n x n     
Y3=lmivar(2,[m n ]); % declare Y as a n x n     
Q=lmivar(2,[1 n]); % declare    
for j=1:h
lmiterm([1 1 1 P],A(:,:,1),E','s') % A*P*E' + *
lmiterm([1 1 1 Q],A(:,:,1)*S,1,'s') % A*S*Q+*
lmiterm([1 1 1 Y],B,1,'s') % B*Y+*

lmiterm([2 1 1 P],A(:,:,2),E','s') % A*P*E' + *
lmiterm([2 1 1 Q],A(:,:,2)*S,1,'s') % A*S*Q+*
lmiterm([2 1 1 Y2],B,1,'s') % B*Y+*

lmiterm([3 1 1 P],A(:,:,3),E','s') % A*P*E' + *
lmiterm([3 1 1 Q],A(:,:,3)*S,1,'s') % A*S*Q+*
lmiterm([3 1 1 Y3],B,1,'s') % B*Y+*
% lmiterm([1 1 1 P],2*5,1,'s') % B*Y+*
lmiterm([-2 1 1 P],1,1,'s') % P>0
end
% lmiterm([-3 1 1 Q],1,1) % P>0
Con=getlmis;
% c = mat2dec(Con,eye(3),eye(3),eye(1,n));
% options = [1e5,0,0,0,0];
% [copt,b] = mincx(Con,c,options);
[tmin b]=feasp(Con);
% [tmin b]=mincx(Con,-trac);
P=dec2mat(Con,b,P);
Y=dec2mat(Con,b,Y);
Y2=dec2mat(Con,b,Y2);
Y3=dec2mat(Con,b,Y3);
Q=dec2mat(Con,b,Q);
K(:,:,1)=Y/((P*E'+S*Q));
K(:,:,2)=Y2/((P*E'+S*Q));
K(:,:,3)=Y3/((P*E'+S*Q));
lamda(1)=deig(A(:,:,1)+B*K(:,:,1),E);
lamda(2)=deig(A(:,:,2)+B*K(:,:,2),E);
lamda(3)=deig(A(:,:,3)+B*K(:,:,3),E);
end
