function [Ee, Ae, Be, Ce, N ] =dapproach (A,B,C,D)
% [Ee, Ae, Be, Ce, Bde, Dde ] =dapproach (E,A,B,Bd,C,D)
% transforma a state space LTI or LPV systems into a descriptor system,
% to estimate sensor faults

n=size(A,1);
m=size(B,2);
p=size(C,1);
l=size(D,2);

h=size(A,3);

Ee=[eye(n) zeros(n,p);
    zeros(p,n+p)];
Ce=[C eye(p)];
N=[zeros(n,p); eye(p)];

for j=1:h
Ae(:,:,j)=[A(:,:,j) zeros(n,p);
           zeros(p,n) -eye(p) ];
end

for j=1:size(B,3)
Be(:,:,j)=[B(:,:,j); 
    zeros(p,m) ];
end

