function [Ccon, Rcon, Icon]=dcontr (E,A,B)
         
ihs = nargin;
ohs=nargout; 
      % This fuction compute the C-Controlability, R-Controlability and I-Controlability, according with the next methods
      %This function chel the next condition for C-Controability
      %1.  The slow subsystem  is C-Controlable if and only if
      %$rank\begin{bmatrix}sE-A & B\end{bmatrix}=n,\,\,\,\forall s\in\mathbb{C},\,\, s\, finite$
     
   
     Cslow=[E-A B];
     nCs=rank(Cslow);
%2. The fast subsystem  is C-Controlable if and only if
        %$rank\begin{bmatrix}E &  & B\end{bmatrix}=n$

        Cfast=[E B];
        nCf=rank(Cfast);
        if  nCs==nCf 
% System  is C-controllable if and only if slow  and fast subsystems are C-Controllable
            nC.Contr='Rank of C-slow = C-fast matrices. The system is controllable';
            nC.Rank=nCs;
        else
            nC.Contr='Rank of C-slow and C-fast matrices are differents';
            nC.Ranks=[nCs nCf];
        end
        
      if nCs==nCf         
        Ccon.Des= 'The system is C-Controllable';
        Ccon.Ranks=[nCs nCf];
        Ccon.Fast=Cfast;
        Ccon.Slow=Cslow;
      else
           Ccon.Des= 'The system is not C-Controllable';
        Ccon.Ranks=[nCs nCf];
        Ccon.Fast=Cfast;
        Ccon.Slow=Cslow;
      end
        
        
%The regular descriptor system  is R-Controlable if and only if
%$rank\begin{bmatrix}sE-A & B\end{bmatrix}=n,\,\,\,\forall s\in\mathbb{C},\,\, s\, finite$
nR.Des='Rank of R-Controllability matrix';
nR.Rank=nCs;

if nCs==size(E,1) 
Rcon.Des='The system is R-Controllable';
Rcon.Rank=nCs;
Rcon.Mat=Cslow;
else
    Rcon.Des='The system is not R-Controllable';
Rcon.Rank=nCs;
Rcon.Mat=Cslow;
end



%The regular descriptor system is I-Controlable if and only if
%$rank\begin{bmatrix}E & 0 & 0\\A & E & B \end{bmatrix}=n+rank\, E$

Imat=[E zeros(size(E,1), size(E,2)) zeros(size(B,1), size(B,2)); A E B];
I_mat.Des='I-controllability matrix';
I_mat.Mat=Imat;
nIa=rank(Imat);

if nIa== size(E,1)+rank(E)
   Icon.Des='The system is I-Controllable ';
   Icon.Rank=nIa;
   Icon.Mat=Imat;
else
   Icon.Des='The sytem is not Controlable ';
   Icon.Rank=nIa;
   Icon.Mat=Imat;
end

