function [K,lamda,g]=dfeedback_control(E,A,B,Bd,C,D,S,flag)
% [K,lamda]=dfeedback_control(E,A,B,S,flag)
% Verify admissiblity for  feedback control
%flag=1 Yalmip, flag=2 cvx, flag=3 LMILAB
% u=Kx, then  the close loop system is 
% Given a scalar γ > 0 and the continuous singular system in
% (5.1) and (5.2). There exists a state feedback controller in (5.21) such that the
% closed-loop system in (5.22) and (5.23) is admissible and its transfer function
% G cK (s) = (C + B 2 K) [sI − (A + B 1 K)]⁻1B
B1=B;
B2=D;
B=Bd;

n=size(A,1);
m=size(B1,2);
p=size(C,1);
if flag==1
P=sdpvar(n,n);
Y=sdpvar(m,n,'full');
Q=sdpvar(1,n,'full');
sdpvar g
% g=0.1
alpha=0;
Con=[P>=0,g>=0];
LMI=blkvar();
LMI(1,1)= (P*E'+S*Q)'*A'+Y'*B1'+A*(P*E'+S*Q)+B1*Y+B*B'+2*alpha*P;
LMI(1,2)=E*P'*C'+Q'*S'*C'+Y'*B2';
% (P*E'+S*Q)'*C'+Y'*B2';
LMI(2,2)=-g*eye(p);
LMI=sdpvar(LMI);
Con=[Con, LMI<=0]
op=sdpsettings('verbose',0,'solver','sedumi','sedumi.eps',1e-5);
solvesdp(Con,[],op)

P=double(P);
Y=double(Y);
Q=double(Q);
g=double(g);
%  K=Y/((P*E'+S*Q))
K=Y/((P*E'+S*Q))
lamda=deig(A+B1*K,E)
% [Ccon, Rcon, Icon]=dcontr (E,A+B*K,B)
elseif flag==2
   %    g=0.01100
cvx_begin sdp
cvx_precision default
cvx_solver sedumi
variable g
variable P(n,n) symmetric
variable Y(m,n)
variable Q(1,n)
minimize g
P >= 0
[  (P*E'+S*Q)'*A'+Y'*B1'+A*(P*E'+S*Q)+B1*Y+B*B' E*P'*C'+Q'*S'*C'+Y'*B2' ; ...
 (E*P'*C'+Q'*S'*C'+Y'*B2')' -g*eye(p)] <= 0
cvx_end

gamma = sqrt(g)
K=Y/((P*E'+S*Q));
lamda=deig(A+B1*K,E)

else

    setlmis([]);
% create a blank LTI framework
P=lmivar(1,[n 1]); % declare X as a 3 × 3 symmetrical matrix    
Y=lmivar(2,[m n]); % declare Y as a n x n     
Q=lmivar(2,[1 n]); % declare    
lmiterm([1 1 1 P],A,E','s') % A*P*E' + *
lmiterm([1 1 1 Q],A*S,1,'s') % A*S*Q+*
lmiterm([1 1 1 Y],B1,1,'s') % B*Y+*
lmiterm([1 1 1 0],B*B') % B*B'+*
lmiterm([1 1 2 P'],E,C') % E*P'*C'
lmiterm([1 1 2 Q'],1,S'*C') % Q'*S'*C'
lmiterm([1 1 2 Y'],1,B2') % E*P'*C'
% lmiterm([1 1 1 P],2*5,1,'s') % B*Y+*
lmiterm([-2 1 1 P],1,1,'s') % P>0
% lmiterm([-3 1 1 Q],1,1) % P>0
Con=getlmis;
% c = mat2dec(Con,eye(3),eye(3),eye(1,n));
% options = [1e5,0,0,0,0];
% [copt,b] = mincx(Con,c,options);
[tmin b]=feasp(Con);
% [tmin b]=mincx(Con,-trac);
P=dec2mat(Con,b,P);
Y=dec2mat(Con,b,Y);
Q=dec2mat(Con,b,Q);
K=Y/((P*E'+S*Q));
lamda=deig(A+B*K,E);

end
