function [Ak,Ek,Bk,Ck,g]=out_dfeedback_control(E,A,B,Bd,C,D,S,flag)
% [Ak,Ek,Bk,Ck,g]=out_dfeedback_control(E,A,B,Bd,C,D,S,flag)
% S any matrix such that E*S=0
%dynamic output feedback controller:
% flag=1 Yalmip, flag=2 cvx, flag=3=LMILAB
% E2dz=Kx, then  the close loop system is 
%reference see 
%Shengyuan Xu James Lam (2011). Chap5 Robust Control and Filtering of Singular Systems

H=C;
B1=B;
B2=D;
B3=B2;
B=Bd;
h=size(A,3);
n=size(A,1);
m=size(B1,2);
p=size(C,1);
if flag==1
X=sdpvar(n,n);
Y=sdpvar(n,n,'full');
Phi=sdpvar(n,p,'full');
Vphi=sdpvar(m,n,'full');
sdpvar g
% g=0.1
alpha=0;
Con=[[E' zeros(n); zeros(n) E]*[X eye(n) ;eye(n) Y]==[X' eye(n) ; eye(n) Y']*[E zeros(4); zeros(4) E']];
Con=[Con, [E' zeros(n); zeros(n) E]*[X eye(n) ;eye(n) Y]>=0]
  
LMI=blkvar();
LMI(1,1)=A'*X+X'*A+Phi*H+H'*Phi';
LMI(1,2)=X'*B
LMI(1,3)=C';
LMI(2,2)=-g*eye(1);
LMI(3,3)=-eye(p);
LMI=sdpvar(LMI)
% 
LMI2=blkvar();
LMI2(1,1)= Y'*A'+A*Y-Vphi'*B1'-B1*Vphi;
LMI2(1,2)=B;
LMI2(1,3)=Y'*C'-Vphi'*B2';
LMI2(2,2)=-g*eye(1);
LMI2(3,3)=-eye(p);
LMI2=sdpvar(LMI2);
Con=[Con, LMI<=0,LMI2<=0]
op=sdpsettings('verbose',0,'solver','sedumi','sedumi.eps',1e-5);
solvesdp(Con,g,op)

X=double(X);
Y=double(Y);
Phi=double(Phi);
Vphi=double(Vphi);
g=sqrt(double(g));

Ak=1/((inv(Y)-X))'*((X'*B1+Phi*B3+C'*B2)*Vphi*inv(Y)-X'*A...
    -Phi*H-(1/g^2)*X'*B*B'*inv(Y)-C'*C-A'*inv(Y));
Ek=E;
Bk=1/(inv(Y)-X)'*Phi;
Ck=-Vphi/(Y);
% [Ccon, Rcon, Icon]=dcontr (E,A+B*K,B)
elseif flag==2
   
setlmis([]);
% create a blank LTI framework
P=lmivar(1,[n 1]); % declare X as a 3 × 3 symmetrical matrix    
Y=lmivar(2,[m n]); % declare Y as a n x n     
Q=lmivar(2,[1 n]); % declare    
lmiterm([1 1 1 P],A,E','s') % A*P*E' + *
lmiterm([1 1 1 Q],A*S,1,'s') % A*S*Q+*
lmiterm([1 1 1 Y],B1,1,'s') % B*Y+*
lmiterm([1 1 1 0],B*B') % B*B'+*
lmiterm([1 1 2 P'],E,C') % E*P'*C'
lmiterm([1 1 2 Q'],1,S'*C') % Q'*S'*C'
lmiterm([1 1 2 Y'],1,B2') % E*P'*C'
% lmiterm([1 1 1 P],2*5,1,'s') % B*Y+*
lmiterm([-2 1 1 P],1,1,'s') % P>0
% lmiterm([-3 1 1 Q],1,1) % P>0
Con=getlmis;
% c = mat2dec(Con,eye(3),eye(3),eye(1,n));
% options = [1e5,0,0,0,0];
% [copt,b] = mincx(Con,c,options);
[tmin b]=feasp(Con);
% [tmin b]=mincx(Con,-trac);
P=dec2mat(Con,b,P);
Y=dec2mat(Con,b,Y);
Q=dec2mat(Con,b,Q);
K=Y/((P*E'+S*Q));
lamda=deig(A+B*K,E);
else
%    g=0.01100
cvx_begin sdp
cvx_precision default
cvx_solver sedumi
variable g
variable X(n,n) symmetric
variable Y(n,n) 
variable Phi(n,p)
variable Vphi(m,n)

minimize g

[E' zeros(n); zeros(n) E]*[X eye(n) ;eye(n) Y]==[X' eye(n) ; eye(n) Y']*[E zeros(4); zeros(4) E']
[E' zeros(n); zeros(n) E]*[X eye(n) ;eye(n) Y]>=0
[A'*X+X'*A+Phi*H+H'*Phi' X'*B C';
 B'*X   -g*eye(1) zeros(1,p);
  C    zeros(p,1)  -eye(p)    ]<=0

[Y'*A'+A*Y-Vphi'*B1'-B1*Vphi B  Y'*C'-Vphi'*B2';
   B'  -g*eye(1) zeros(1,p)    ;
  (Y'*C'-Vphi'*B2')'  zeros(1,p)' -eye(p)]<=0
cvx_end

gamma = sqrt(g)
Ak=(inv(Y)-X)'*((X'*B1+Phi*B3+C'*B2)*Vphi*inv(Y)-X'*A...
    -Phi*H-(1/g^2)*X'*B*B'*inv(Y)-C'*C-A'*inv(Y));
Ek=E;
Bk=(inv(Y)-X)'*Phi;
Ck=Vphi*inv(Y);
end
